from Packages import *
from Class_Mod.Miscellaneous import *
from Class_Mod.Regression_metrics import metrics




class PlsR:
    def __init__(self, x_train, y_train, x_test, y_test):
        self.x_train = x_train
        self.x_test = x_test 
        self.y_train = y_train
        self.y_test = y_test
    
        self.trained = PLSRegression(n_components= self._optimize(), scale = False)
        self.trained.fit(self.x_train, self.y_train)

        self.yc = pd.DataFrame(self.trained.predict(self.x_train)) # make predictions on test data and assign to Y_preds variable
        self.ycv = pd.DataFrame(cross_val_predict(self.trained, self.x_train, self.y_train, cv = 3)) # make predictions on test data and assign to Y_preds variable
        self.yt = pd.DataFrame(self.trained.predict(self.x_test)) # make predictions on test data and assign to Y_preds variable


    def _optimize(self):
        nlv = 21
        rmse = np.ones(21)
        rmse[0] = 0.002
        lv = {}
        ratio = []
        for i in range(1,nlv):
            m = PLSRegression(n_components= i, scale = False)
            ycv = cross_val_predict(m, self.x_train, self.y_train, cv = 5)
            rmse[i] = mean_squared_error(self.y_train, ycv)

            ratio.append(((rmse[i-1]-rmse[i])/rmse[i-1])*100)
        return np.argmax(ratio)+1

        ################################################################################################################
        

        ################################################################################################################

    @property
    def model_(self):
        return self.trained
    
    @property
    def metrics_(self):
        metc = metrics(self.y_train, self.yc)
        metc = metc.evaluate_

        metcv = metrics(self.y_train, self.ycv)
        metcv = metcv.evaluate_

        mett = metrics( self.y_test, self.yt)
        mett = mett.evaluate_
        
        met = pd.concat([metc, metcv, mett], axis = 0)
        met.index = ['calib','cv','test']
        return met

    @property
    def pred_data_(self):
        
        return self.yc, self.ycv, self.yt